/**
	This file is part of Hedge Maze.

    Hedge Maze is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    Hedge Maze is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with Hedge Maze.  If not, see <http://www.gnu.org/licenses/>.

	Copyright 2006, 2010 James Hill
*/
#ifndef PLAYER_H
#define PLAYER_H

#include <d3dx9.h> // used for the D3D vector structure

class player
{
public:

	// the constructor will do nothing
	player();

	// the destructor will probably do nothing
	~player();

	// initialize position and look at.
	void setPosition(float x, float z);
	void setLookat(float x, float z);
	void setRight(float x, float z);
	void setFront(float x, float z);
	void setpx(float x) {px=x;};
	void setpz(float z) {pz=z;};
	void setlx(float x) {lx=x;};
	void setlz(float z) {lz=z;};

	// retrieve those values
	D3DXVECTOR3 getPosition();
	D3DXVECTOR3 getLookAt();

	// translate along the major axis
	void transRight(float amount, bool xdir, bool zdir);
	void transForward(float amount, bool xdir, bool zdir);

	// rotate about y axis
	void rotate(float angle);

private:

	float px, pz; // position vectors
	float lx, lz; // look at vector
	float rx, rz; // right vector
	float fx, fz; // front vector
};

#endif //PLAYER_H